<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 42</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Vùng header-->
    <div class="container">
        <div class="text-center mt-3">
            <h2>DANH SÁCH ĐƠN HÀNG</h2>
        </div>
    </div>
    <!--User Data Table-->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="order-table">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã đơn hàng</th>
                    <th>Họ và tên</th>
                    <th>Payment Method</th>
                    <th>Số lượng sản phẩm</th>
                    <th>Tổng tiền</th>
                    <th>Ngày đặt hàng</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!--Vùng Modal-->
    <!--Update Product modal-->
    <div>
        <div id="update-order-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết Đơn hàng</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-lastName">Họ và đệm</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-lastName" name="lastName"
                                        placeholder="Họ và dệm" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-name">Tên</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-name" name="name" placeholder="Tên"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-email">Email</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-email" name="email" placeholder="Email"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-phone">Phone</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-phone" name="phone" placeholder="Phone number"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-address">Address</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-address" name="address" placeholder="Address"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-update-payment-method" class="col-form-label col-sm-4">Payment
                                    Method</label>
                                <div class="col-sm-8">
                                    <select id="select-update-payment-method" class="form-control">
                                        <option value="Paypal">Paypal</option>
                                        <option value="CreditCard">Credit Card</option>
                                        <option value="BankTransfer">Bank Transfer</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4" for="input-update-discount-code">Mã giảm
                                    giá</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-discount-code" name="discountCode"
                                        placeholder="Mã giảm giá" class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-update-order">Update Order</button>
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Hủy</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Confirm Xóa Order</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa order này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-order">Xác nhận</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global Variables */
    const gBASE_URL = "https://food-ordering-fvo9.onrender.com/api";
    //Biến toàn cục để lưu trữ id order đang được update or delete. Mặc định = 0;
    var gOrderId = 0;

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gORDER_COLS = ["stt", "orderCode", "fullName", "methodPayment", "foodNumber", "totalPrice", "createdAt"];

    //Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gORDER_STT_COL = 0;
    const gORDER_ORDER_CODE_COL = 1;
    const gORDER_FULL_NAME_COL = 2;
    const gORDER_METHOD_PAYMENT_COL = 3;
    const gORDER_FOOD_NUMBER_COL = 4;
    const gORDER_TOTAL_PRICE_COL = 5;
    const gORDER_CREATED_AT_COL = 6;
    const gORDER_ACTION_COL = 7;

    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gOrderTable = $("#order-table").DataTable({
        columns: [
            { data: gORDER_COLS[gORDER_STT_COL] },
            { data: gORDER_COLS[gORDER_ORDER_CODE_COL] },
            { data: gORDER_COLS[gORDER_FULL_NAME_COL] },
            { data: gORDER_COLS[gORDER_METHOD_PAYMENT_COL] },
            { data: gORDER_COLS[gORDER_FOOD_NUMBER_COL] },
            { data: gORDER_COLS[gORDER_TOTAL_PRICE_COL] },
            { data: gORDER_COLS[gORDER_CREATED_AT_COL] },
            { data: gORDER_COLS[gORDER_ACTION_COL] }
        ],
        columnDefs: [
            {// định nghĩa lại cột STT
                targets: gORDER_STT_COL,
                render: function () {
                    return gSTT++;
                }
            },
            {// định nghĩa cột fullname
                targets: gORDER_FULL_NAME_COL,
                render: function (data, type, row) {
                    var result = row["firstName"] + row["lastName"];
                    return result;
                }
            },
            {
                targets: gORDER_FOOD_NUMBER_COL,
                render: function (data, type, row) {
                    var result = row["foods[2]"] + row["foods[2]"] + row["foods[2]"];
                    return result;
                }
            },
            { // định nghĩa cột action
                targets: gORDER_ACTION_COL,
                defaultContent: `
                    <img class="edit-order" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-order" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `
            }
        ]
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        // thực hiện tải trang
        onPageLoading();
    });

    // gán sự kiện Update - sửa 1 order
    $("#order-table").on("click", ".edit-order", function () {
        onBtnEditOrderClick(this);
    });

    // gán sự kiện Delete - xoa 1 order
    $("#order-table").on("click", ".delete-order", function () {
        onBtnDeleteOrderClick(this);
    });

    // gán sự kiện cho nút Update Order (trên modal)
    $("#btn-update-order").on("click", function () {
        onBtnUpdateOrderClick();
    });

    // gán sự kiện cho nút Confirm Delete User (trên modal)
    $("#btn-confirm-delete-order").on("click", function () {
        onBtnConfirmDeleteOrderClick();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
        // 1 - R: Read / Load orders to DataTable
        getAllOrders();
    }

    // Hàm xử lý sự kiện khi icon edit order trên bảng được click
    function onBtnEditOrderClick(paramBtnEdit) {
        //lưu thông tin OrderId đang được edit vào biến toàn cục
        gOrderId = getOrderIdFromButton(paramBtnEdit);
        console.log("Id = " + gOrderId);
        //hiển thị modal trắng lên
        $("#update-order-modal").modal("show");
        // load dữ liệu vào các trường dữ liệu trong modal
        getOrderById(gOrderId);
    }

    // hàm xử lý sự kiện update order modal click
    function onBtnUpdateOrderClick() {
        // khai báo đối tượng chứa order data
        var vOrderObj = {
            firstname: "",
            lastname: "",
            email: "",
            phone: "",
            address: "",
            paymentMethod: "",
            discountCode: ""
        };
        // B1: Thu thập dữ liệu
        getUpdateOrderData(vOrderObj);
        // B2: Validate update
        var vIsOrderValidate = validateOrderData(vOrderObj);
        if (vIsOrderValidate) {
            // B3: update order
            $.ajax({
                url: gBASE_URL + "/orders/" + gOrderId,
                type: "PUT",
                contentType: "application/json",
                data: JSON.stringify(vOrderObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleUpdateOrderSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }


    // Hàm xử lý sự kiện khi icon delete order trên bảng được click
    function onBtnDeleteOrderClick(paramBtnEdit) {
        //lưu thông tin OrderId đang được edit vào biến toàn cục
        gOrderId = getOrderIdFromButton(paramBtnEdit);
        console.log("Id = " + gOrderId);
        //hiển thị modal trắng lên
        $("#delete-confirm-modal").modal("show");
    }

    // // Hàm xử lý sự kiện khi nút confirm delete order trên modal được click
    function onBtnConfirmDeleteOrderClick() {
        $.ajax({
            url: gBASE_URL + "/orders/" + gOrderId,
            type: "DELETE",
            success: function (paramRes) {
                // B4: xử lý front-end
                handleDeleteOrderSuccess();
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách orders
    function getAllOrders() {
        $.ajax({
            url: gBASE_URL + "/orders",
            type: "GET",
            success: function (paramOrders) {
                loadDataToOrderTable(paramOrders);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    /** load orders array to DataTable
   * in: order array
   * out: order table has data
   */
    function loadDataToOrderTable(paramOrderArr) {
        gSTT = 1;
        gOrderTable.clear();
        gOrderTable.rows.add(paramOrderArr);
        gOrderTable.draw();
    }


    // hàm dựa vào button detail (edit or delete) xác định được id order
    function getOrderIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vOrderRowData = gOrderTable.row(vTableRow).data();
        return vOrderRowData.id;
    }

    // hàm get order by id
    function getOrderById(paramOrderId) {
        $.ajax({
            url: gBASE_URL + "/orders/" + paramOrderId,
            type: "GET",
            success: function (paramOrder) {
                showOrderDataToModal(paramOrder);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
    }

    // hàm show order obj lên modal
    function showOrderDataToModal(paramOrder) {
        $("#input-update-lastName").val(paramOrder.lastName);
        $("#input-update-name").val(paramOrder.firstName);
        $("#input-update-email").val(paramOrder.email);
        $("#input-update-phone").val(paramOrder.phone);
        $("#input-update-address").val(paramOrder.address);
        $("#select-update-payment-method").val(paramOrder.methodPayment);
        $("#input-update-discount-code").val(paramOrder.voucherId);
    }

    // hàm thu thập dữ liệu để update order
    function getUpdateOrderData(paramOrderObj) {
        paramOrderObj.lastName = $("#input-update-lastName").val().trim();
        paramOrderObj.firstName = $("#input-update-name").val().trim();
        paramOrderObj.email = $("#input-update-email").val().trim();
        paramOrderObj.phone = $("#input-update-phone").val().trim();
        paramOrderObj.address = $("#input-update-address").val().trim();
        paramOrderObj.methodPayment = $("#select-update-payment-method").val();
        paramOrderObj.voucherId = $("#input-update-discount-code").val().trim();
    }

    // hàm validate data
    function validateOrderData(paramOrderObj) {
        if (paramOrderObj.lastName === "") {
            alert("Enter Lastname!");
            return false;
        }

        if (paramOrderObj.firstName === "") {
            alert("Enter name!");
            return false;
        }

        if (paramOrderObj.email === "") {
            alert("Enter Email!");
            return false;
        } else {
            if (!validateEmail(paramOrderObj.email)) {
                alert("Email không đúng định dạng !");
                return false;
            }
        }
        //kiểm tra sdt
        if (!paramOrderObj.phone) {
            alert("phone number must be entered !");
            return false;
        } else if (isNaN(paramOrderObj.phone)) {
            alert("Điện thoại phải là số!\n");
            return false;
        } else if (!validatePhone(paramOrderObj.phone)) {
            alert("Điện thoại không đúng định dạng !\n");
            return false;
        }
        return true;
    }

    // hàm kiểm tra email đúng định dạng ko?
    function validateEmail(paramEmail) {
        var vValidRegex =
            /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        if (paramEmail.match(vValidRegex)) {
            return true;
        } else {
            return false;
        }
    }
    // hàm kiểm tra số điện thoại đúng định dạng ko?
    function validatePhone(paramPhone) {
        var vValidRegex = /((0|\+)+([0-9]{9,11})\b)/g;
        if (paramPhone.match(vValidRegex)) {
            return true;
        } else {
            return false;
        }
    }

    // hàm xử lý hiển thị front-end khi sửa order thành công
    function handleUpdateOrderSuccess() {
        alert("Sửa order thành công!");
        getAllOrders();
        resertUpdateOrderForm();
        $("#update-order-modal").modal("hide");
    }

    // hàm xóa trắng form update order
    function resertUpdateOrderForm() {
        $("#input-update-lastName").val("");
        $("#input-update-name").val("");
        $("#input-update-email").val("");
        $("#input-update-phone").val("");
        $("#input-update-address").val("");
        $("#select-update-payment-method").val("Paypal");
        $("#input-update-discount-code").val("");
    }

    // hàm xử lý hiển thị front-end khi xóa order thành công
    function handleDeleteOrderSuccess() {
        alert("Delete order thành công!");
        getAllOrders();
        $("#delete-confirm-modal").modal("hide");
    }
</script>

</html>